# Multiple bubble tracking in bubbly flows 


The present repository contains the code to track multiple bubbles in bubbly flows as descirbed in *Fate of bubble clusters rising in quiescent liquid*,
which is based on the paper *Learning a Neural Solver for Multiple Object Tracking* 
[[Paper]](https://arxiv.org/abs/1912.07515)[[Github]](https://github.com/dvl-tum/mot_neural_solver) 


## Setup

1. Download this repository from [[Rodare]](https://rodare.hzdr.de/).

2. Create an [Anaconda environment](https://docs.conda.io/projects/conda/en/latest/user-guide/tasks/manage-environments.html) for this project:
    1. `conda env create -f environment_tracking.yaml`
    2. `conda activate mot_neural_solver_bub`
    3. `pip install -e .`

For windows you can use the environment_win.yaml. Note the gpu usage has to be included manually in this case, which is recommended for training, but not necessary for pure prediction.

3. (**RECOMMENDED**) It is highly recommended to use our [[bubble detection]](https://doi.org/10.14278/rodare.1470) to provide the correct detection input. If you use your own detector, make sure to transform the segmentations in radial distances.

Currently the model only works for bubbles with similar or less pixel displacement as in the exmaple images. 

# More documentation and clean-up will follow!

If you have questions, please contact h.hessenkemper@hzdr.de





