from mot_neural_solver_bub.pl_module.pl_module import MOTNeuralSolver
from sacred import Experiment
from mot_neural_solver_bub.data.splits import _SPLITS
from mot_neural_solver_bub.path_cfg import PROJECT_PATH
from mot_neural_solver_bub.utils.draw import visualize,read_In
import os.path as osp

drawResults=True

ex = Experiment("test",interactive=True)
ex.add_config(osp.join(PROJECT_PATH,'configs/bub_tracking_cfg.yaml'))
_config=ex.configurations[0]._conf
model = MOTNeuralSolver.load_from_checkpoint(hparams = dict(_config),checkpoint_path=str(PROJECT_PATH)+_config['ckpt_path'])
model.hparams.update({'eval_params':_config['eval_params'],
                          'data_splits':_config['data_splits']})

out_files_dir=str(PROJECT_PATH)+'/TrackingTest/'
names=[] 
names.append('/Example')
_SPLITS['test']={str(PROJECT_PATH):names}  
test_dataset = model.test_dataset()
constr_satisf_rate = model.track_all_seqs(dataset=test_dataset,
                                              output_files_dir = out_files_dir,
                                              use_gt = False,
                                              verbose=False)


if drawResults:
    tracks=read_In(out_files_dir+names[0]+'.txtRes')
    visualize(0,10,tracks,str(PROJECT_PATH)+names[0],ident='jpg',save=True)