import os
import cv2
from tqdm import trange
from pathlib import Path
import numpy as np
import pandas as pd
from scipy.ndimage.filters import uniform_filter1d

def read_In(name):
    track_df=pd.read_csv(name,
    sep=',',
    skipinitialspace=True,
    header=0,
    )
    if 'level_0' in track_df.columns:
        track_df=track_df.drop(['level_0'],axis=1)
    track_df = track_df.reset_index().sort_values(by=['frame']) 
    for i in track_df['ped_id'].unique(): 
        px=track_df[track_df.ped_id==i]['posx'].values
        track_df.loc[track_df.ped_id==i,'posx']=uniform_filter1d(px, size=4) 
    track_df=track_df.rename(columns={'ped_id':'id'})
    return track_df
def visualize(start,end,det_df,name,outname='/TrackVis',ident='png',save=False,max_Before='max',s=5,case=1,plotbb=False,plotid=False,id='max'):
    print(name+outname)
    if save==True:
        os.makedirs(name+outname, exist_ok=True)
    Labels=sorted(Path(name).glob('*'+ident))
    assert len(Labels)>1, "No GT images found"
    if case==1:
        Labels.sort(key=lambda x:int((x.name.split("_")[1].split(".")[0])))
    else:
        Labels.sort(key=lambda x:int((x.name.split(".")[0])))
    colors=[] 
    for i in range(len(det_df)):
        random_color=tuple((np.random.choice(range(255),size=3))) 
        colors.append(random_color)
    for frame in trange(start,end):  

        img=cv2.imread(str(Labels[frame]))  
        for j,i in enumerate(det_df['id'].unique()):     
            if max_Before=='max':
                start_bef=0
            else:
                start_bef=frame-max_Before if frame-max_Before>start else start
            if (i in det_df[det_df.frame==frame]['id'].values):
                xs=det_df[det_df.frame<=frame][det_df.frame>=start_bef][det_df.id==i]['posx'].values
                ys=det_df[det_df.frame<=frame][det_df.frame>=start_bef][det_df.id==i]['posy'].values
                color=(int(colors[j][0]),int(colors[j][1]),int(colors[j][2]))
                for k in range(1,len(xs)):
                    img=cv2.line(img,(int(xs[k-1]),int(ys[k-1])),(int(xs[k]),int(ys[k])), color=color,thickness=3)
        if save==True:
            cv2.imwrite(name+outname+'/_'+str(frame)+'.png',img)